unit hiBASS_Video;

interface

uses Kol,Windows,Share,Debug,BassVideo,Bass;

type
  TCallback = packed record
    POPEDX: Byte;
    MOVEAX: Byte;
    SelfPtr: Pointer;
    PUSHEAX: Byte;
    PUSHEDX: Byte;
    JMP: Byte;
    JmpOffset: Integer;
  end;

type
  THIBASS_Video = class(TDebug)
   private
   //WndH: HWND;
   FName: string;
   Chan: DWORD;
   Callback:TCallback;
   function MyVideoStream(Handle : DWORD; Action, param1,
             param2 : DWORD; user : Pointer): BOOL; stdcall;

   public
    _prop_Filename:string;

    _data_Handle:THI_Event;
    _data_FileName:THI_Event;
    _event_onEndPlay:THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure Init;

    procedure _work_doOpenFile(var _Data:TData; Index:word);
    procedure _work_doPlay(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _work_doPause(var _Data:TData; Index:word);
    procedure _work_doPosition(var _Data:TData; Index:word);
    procedure _work_doVolume(var _Data:TData; Index:word);
    procedure _work_doCaptureBitmap(var _Data:TData; Index:word);
    procedure _var_Position(var _Data:TData; Index:word);
    procedure _var_Length(var _Data:TData; Index:word);
  end;

implementation

var WndH: HWND;

procedure THIBASS_Video.Init;
begin
  if not Bass_Init(-1, 44100, 0, 0, nil) then
  begin
    //MessageBox(Handle,MsgError(BASS_ErrorGetCode),'Error',MB_OK);
    halt;
  end;

  if not BASSVideo_Init then halt;
  BassVideo_SetConfig(BassVideo_Default, 1);
end;

function THIBASS_Video.MyVideoStream(Handle : DWORD; Action, param1,
         param2 : DWORD; user : Pointer): BOOL; stdcall;
var R: TRect;
begin
 case Action of
  BassVideo_FoundVideo :
    begin
      GetWindowRect(WndH,R);
      R.Left := 0;
      R.Top := 0;
      BASSVideo_SetVideoWindow(Handle, WndH, R, 0);
    end;
  BassVideo_EndStream : _hi_onEvent(_event_onEndPlay,'');

 end;
 result := FALSE; // doesn't handle any msg
end;

constructor THIBASS_Video.Create;
begin
inherited Create;
  Callback.POPEDX := $5A;
  Callback.MOVEAX := $B8;
  Callback.SelfPtr := Self;
  Callback.PUSHEAX := $50;
  Callback.PUSHEDX := $52;
  Callback.JMP := $E9;
  Callback.JmpOffset := Integer(@THIBASS_Video.MyVideoStream) -
                        Integer(@Callback.JMP) - 5;

  Init;
  Chan := 0;
end;

destructor THIBASS_Video.Destroy;
begin
 FName := '';
 inherited Destroy
end;

procedure THIBASS_Video._work_doOpenFile;
begin
  FName := ReadString(_Data,_data_FileName,_prop_FileName);
  WndH := ReadInteger(_Data,_data_Handle,0);
  if(Chan<>0) then BassVideo_StreamFree(Chan);
  Chan := BassVideo_StreamCreateFile(PChar(FName),
          BASSVIDEO_AUTO_PAINT or BASSVIDEO_AUTO_RESIZE or BASSVIDEO_AUTO_MOVE,
          0, @Callback, nil);
  //BassVideo_Play(Chan);
end;

procedure THIBASS_Video._work_doPlay;
begin
  BassVideo_Play(Chan);
end;

procedure THIBASS_Video._work_doStop;
begin
  BassVideo_Stop(Chan);
end;

procedure THIBASS_Video._work_doPause;
begin
  BassVideo_Pause(Chan);
end;

procedure THIBASS_Video._work_doPosition;
begin
  BassVideo_SetPosition(chan, ToInteger(_Data));
end;

procedure THIBASS_Video._work_doVolume;
var vol: Real;
begin
  vol := (ToReal(_Data)*0.01);
  BASS_ChannelSetAttribute(Chan, BASS_ATTRIB_VOL, vol);
end;

procedure THIBASS_Video._work_doCaptureBitmap;
var s, fn : widestring;
    pos : Double;
begin
 if Chan = 0 then exit;
  s := widestring(ToString(_Data));
  fn := widestring(FName);
  pos := BassVideo_GetPosition(Chan);
  BassVideo_CaptureBitmap(PWideChar(fn), pos, PWideChar(s), BASS_UNICODE);
end;

procedure THIBASS_Video._var_Position;
begin
  dtInteger(_Data,Round(BASSVideo_GetPosition(chan)));
end;

procedure THIBASS_Video._var_Length;
begin
  dtInteger(_Data,Round(BassVideo_GetLength(chan)));
end;



end.
